﻿using Android.App;
using Android.Content;
using Android.Content.PM;
using Android.Net.Eap;
using Android.OS;
using Android.Widget;
using Microsoft.Maui.Embedding;
using Com.Cipherlab.Barcode;
using Com.Cipherlab.Barcode.Decoderparams;
using Com.Cipherlab.Barcode.Decoder;

namespace MauiApp1
{
    [Activity(Theme = "@style/Maui.SplashTheme", MainLauncher = true, ConfigurationChanges = ConfigChanges.ScreenSize | ConfigChanges.Orientation | ConfigChanges.UiMode | ConfigChanges.ScreenLayout | ConfigChanges.SmallestScreenSize | ConfigChanges.Density)]
    public class MainActivity : MauiAppCompatActivity
    {        
        private MauiContext _mauiContext;

        static ReaderManager m_RM = null;
        private IntentFilter filter = null;
        private DataReceiver myDataReceiver = null;        

        protected override void OnCreate(Bundle bundle)
        {
            base.OnCreate(bundle);

            // Reader InitInstance
            m_RM = ReaderManager.InitInstance(this);
            myDataReceiver = new DataReceiver();

            filter = new IntentFilter();
            filter.AddAction("com.cipherlab.barcodebaseapi.SERVICE_CONNECTED");
            filter.AddAction("com.cipherlab.barcodebaseapi.PASS_DATA_2_APP");
            RegisterReceiver(myDataReceiver, filter);

            MauiAppBuilder builder = MauiApp.CreateBuilder();
            builder.UseMauiEmbedding<Microsoft.Maui.Controls.Application>();
            MauiApp mauiApp = builder.Build();
            _mauiContext = new MauiContext(mauiApp.Services, this);
        }

        class DataReceiver : BroadcastReceiver
        {
            public string sDataStr = "";

            public override void OnReceive(Context context, Android.Content.Intent intent)
            {
                if (intent.Action == "com.cipherlab.barcodebaseapi.PASS_DATA_2_APP")
                {
                    sDataStr = "";
                    sDataStr = intent.GetStringExtra("Decoder_Data");

                    Toast.MakeText(context, sDataStr, ToastLength.Short).Show();

                    (App.Current as App).HandleDecodeData(sDataStr);
                }
                else if (intent.Action == "com.cipherlab.barcodebaseapi.SERVICE_CONNECTED")
                {
                    if(intent.GetStringExtra("PackageName").Equals("com.companyname.mauiapp1"))
                    {
                        Toast.MakeText(context, "Connected Reader Service", ToastLength.Short).Show();

                        ReaderOutputConfiguration settings = new ReaderOutputConfiguration();
                        m_RM.Get_ReaderOutputConfiguration(settings);

                        // Intent
                        settings.EnableKeyboardEmulation = KeyboardEmulationType.None;
                        settings.AutoEnterWay = OutputEnterWay.Disable;

                        m_RM.Set_ReaderOutputConfiguration(settings);
                    }
                }
            }
        }
    }
}